import { Entity, Column } from "typeorm";
import { IsInt, IsPositive,} from "class-validator";
import { Donation } from "./Donation";

/**
 * Defines a fixed donation.
*/
@Entity()
export class FixedDonation extends Donation {

  /**
   * The donation's amount in cents (or whatever your currency's smallest unit is.).
   */
  @Column()
  @IsInt()
  @IsPositive()
  amount: number;
}